#include<stdio.h>
#include<string.h>
#include<ctype.h>
#include<math.h>
#include<stdlib.h>
#include<conio.h>
#include<graphics.h>

#define NUMBER 0
#define OPERATION 1
#define ARGUMENT 2
#define FUNCTION 3
#define END 4
#define PI 3.141593

inline void error(char *s){
 outtext("Error ");
 outtext(s);
 getch();
 closegraph();

 exit(1);
}

class TokenString {
 char *ptr;
 char str[81];
 public:
 TokenString(char *s) { strcpy(ptr=str,s); }
 void reset(void) { ptr=str;}
 void gettoken(void);
 int type;
 char t[81];
 double val;
};
void TokenString::gettoken(void) {
 while(isspace(*ptr))
	    ptr++;
	    if(!*ptr){
	    *t=0;
	    type=END;
	    }
	    else if(strchr("+-*/()",*ptr)){
	    t[0]=*ptr++;
	    t[1]=0;
	    type=OPERATION;
	    }
	    else if(toupper(*ptr)=='X'){
	    t[0]=*ptr++;
	    t[1]=0;
	    type=ARGUMENT;
	    }
	    else if(isdigit(*ptr)){
	    int p=0;
	    char *temp=t;
	    while(isdigit(*ptr)||(*ptr=='.'&&!p)){
	    if(*ptr=='.')
		p=1;
	    *temp++=*ptr++;
	    }
	    *temp=0;
	    val=atof(t);
	    type=NUMBER;
	    }
	    else if(isalpha(*ptr)){
	    char *temp;
	    while(isalpha(*ptr)||isdigit(*ptr))
	    *temp++=*ptr++;
	    *temp=0 ;
	    type=FUNCTION;
	    }
	    else {
	    char s[41];
	    sprintf(s,"Bad symbol '%c' %x \n",*ptr,*ptr);
	    error(s);
	    }
}

class Function : private TokenString {
double x;
void primitive(double&);
void level1(double&);
void level2(double&);
void level3(double&);
void level4(double&);
void level5(double&);
public:
 Function(char *f) : TokenString(f){}
 double get(double);
};

double Function::get(double a){
   x=a;
   reset();
   gettoken();
   if(type==END)
	error("No function");
   double result;
   level1(result);
   return result;
}

 void Function :: level1 (double &result) {
	double temp;
	char op;
	level2(result);
	while((op=*t)=='+'||op=='-'){
		gettoken();
		level2(temp);
		if(op=='+')
			result+=temp;
		else
			result-=temp;
		}
 }
 void Function :: level2 (double &result) {
 double temp;
 char op;
 level3(result);
 while((op=*t)=='*'||op=='/'){
 gettoken();
 level3(temp);
 if(op=='*')
	result*=temp;
 else
	result/=temp;
 }
 }
 void Function :: level3 (double &result) {
 int f=0;
 char str[81];
 if(type==FUNCTION) {
 f=1;
 strcpy(str,t);
 gettoken();
 }
 level4(result);
 if(f) {
 strupr(str);
	if(!strcmp("SIN",str))
		result=sin(result);
	else if(!strcmp("COS",str))
		result=cos(result);
	else if(!strcmp("TAN",str))
		result=sin(result)/cos(result);
	else if(!strcmp("ABS",str))
		result=fabs(result);
	else error("Unknown function");
 }
 }

 void Function :: level4(double &result) {
 int sign=0;
 if(*t=='-'){
 sign=1;
 gettoken();
 }
 level5(result);
 if(sign)
 result=-result;
 }
 void Function :: level5(double &result) {
 if(*t=='('){
 gettoken();
 level1(result);
 if(*t!=')')
 error("No "")"" ");
 gettoken();
 }
 else
  primitive(result);
 }
 void Function :: primitive (double &result) {
  switch(type){
    case NUMBER:
	result=val;
	gettoken();
	break;
    case ARGUMENT:
	result=x;
	gettoken();
	break;
    default:
	error("Number or X needed");
  }
 }
 void main(void) {
  char str[81];
  printf("\nPI=%lf\ny=",PI);
  gets(str);
  Function f(str);
  double xs,ys;
  printf("XSIZE=");
  scanf("%lf",&xs);
  printf("YSIZE=");
  scanf("%lf",&ys);

  xs=fabs(xs);
  ys=fabs(ys);

  int n;
  double x1=-xs/2,y1=-ys/2,x2=xs/2,y2=ys/2;
  printf("N=");
  scanf("%d",&n);

int gdriver = DETECT, gmode, errorcode;
initgraph(&gdriver, &gmode, "");
errorcode = graphresult();
if (errorcode != grOk)  /* an error occurred */
{
   printf("Graphics error: %s\n", grapherrormsg(errorcode));
   printf("Press any key to halt:");
   getch();
   exit(1); /* terminate with an error code */
}
double xd=x2-x1,xstep=xd/double(n);
double sxstep=(x2-x1)/double(getmaxx()+1);
double systep=(y2-y1)/double(getmaxy()+1);
setbkcolor(BLUE);
cleardevice();
setcolor(WHITE);
setlinestyle(DOTTED_LINE,0,NORM_WIDTH);
int xx=int(-x1/sxstep);
line(xx,0,xx,getmaxy());

line(0,getmaxy()/2,getmaxx(),getmaxy()/2);

setcolor(YELLOW);
setlinestyle(SOLID_LINE,0,NORM_WIDTH);
double temp=x1;
moveto(0,int((y2-f.get(temp))/systep));
for(int i=1;i<=getmaxx();i++){
temp+=xstep;
double val=f.get(temp);
lineto(int((temp-x1)/sxstep),int((y2-val)/systep));
}

getch();

closegraph();
 }